 /* Reten 27-05-2000    */
/* (c) SETA   Dominio Publico  */
/* xWin  */

#include <unistd.h>
#include <string.h>
#include <time.h>

#include "stdio.h"
#include "stdlib.h"
#include <sys/time.h> 

#include "xxgrafi.h"
#include "objetos.h"

#include "main.h"



#define TIEMPO1		25
#define TIEMPO2		50
#define TIEMPO3		100

//Velocidad de muestreo
// windows lento
#if YesWindows 
    #define XTIEMPO3	2
#else
	#define XTIEMPO3	2
#endif



int tiempo1=TIEMPO1,tiempo2=TIEMPO2, tiempo3=TIEMPO3;
char LVARI[100];

Boton *Bacerca;
Boton *Bexit;

Boton *BDOWN_T;
Boton *BUP_T;

Chequeo *RadioButton1;
Chequeo *RadioButton2;
Chequeo *RadioButton3;
Chequeo *RadioButton4;

TextoS *StaticText1;
TextoS *StaticText2;
TextoS *Titulo;

TextoE *Tvoltios;
TextoE *Tdivisor;
TextoE *Bdevice;


SpinBox * Stimer;
SpinBox * Sdesplazamiento;
TextoS  *Tdesplaza;

SpinBoxS *Szoom;
SpinBoxS  *Sdivisor;

CBoton *BModoDibujo;
       

void Repaint(void);
void Repintado(void);


//_____
void MiTimer();

int SearchPort(char *placa);
int test3v3(void);
void CalldivisorSelect(void);
void OnSzoomSelect(void);
void RepresentarVol(int z);
void Representar(int z);

void ModifiG();


#define MAXENTRADA 50
#define MAXINPUT 1030


int  ContadorI=0;
 char Binput[MAXINPUT];
 char Binput2[10];
char FinContador=1;

int  DatosPan[MAXINPUT];
int	 IndexDatos;
int  xtiempo2=10;

int DIVISION=16;
int MUESTRAS;
int MUESTREO;

int MODO=1;
int MODOLINE;

int DESPLAZAMIENTO;
int ZOOM=1;

int V33;

unsigned char portok;

//_________________________

#if YesWindows
    static 	char *myport[]= {"com1","com2","com3","com4","com5","com6","com7","com8","com9","\\\\.\\COM10","\\\\.\\COM11","\\\\.\\COM12"};
#else
	static char *myport[]= {(char *)"/dev/ttyUSB0", (char *)"/dev/ttyUSB1", (char *)"/dev/ttyACM0", (char *)"/dev/ttyACM1", (char *)"/dev/ttyACM2", (char *)"/dev/ttyS0", (char *)"/dev/ttyS1"};
#endif	

void PrintConsola( char *texto)
{
  Bdevice->Value( (char *) texto);
  Bdevice->Dibujar();
  redraw();
}




int main (int argc, char *argv[])
{
 int z,zz,t,f2;
 int mouse_x,mouse_y;
 XEvent event; 
   
//	init(430,146);
	if(init(800,520) == 0 ) return 1;
	SETBUFFER=1;
	zz=loadfont((char *)"nada");
	paleta();
	INK=5; 
                
	//_______________________	
	Bacerca=new Boton(560,480,(char*)"Acerca");
	Bexit=new Boton(672,480,(char*)"Salir");
	BDOWN_T=new Boton(154,384,32,24,(char*)"*");
	BUP_T=new Boton(154,352,32,24,(char*)"*");
	
	RadioButton1=new Chequeo(16,320,(char*) "Auto");
	RadioButton1->set(1);
	RadioButton2=new Chequeo(16,352,(char*) "Tri. UP");
	RadioButton3=new Chequeo(16,384,(char*) "Tri. DOWN");
	RadioButton4=new Chequeo(16,416,(char*) "Voltimetro");
	
	StaticText1=new TextoS(26,448,(char*) "A0");
	StaticText2=new TextoS(26,480,(char*) "TIMER");
	Titulo=new TextoS(16,280,(char*) "osciXWINv1");
	
	Tvoltios=new TextoE(55,448,(char*) "Volt.");
	Tdivisor=new TextoE(304,408,(char*) "DIVxx");
	Bdevice=new TextoE(570,344,205,24,(char*) "device");
	
	Stimer=new SpinBox(100,480,50,24,7,20,1);
	Sdesplazamiento=new SpinBox(304,312,50,24,0,100,1);
	Tdesplaza=new TextoS(364,314,(char*) "Desplazar");
	
	Szoom=new SpinBoxS(304,344,116,24);
	Szoom->Append((char*)"ZOOMx1");
	Szoom->Append((char*)"ZOOMx2");
    Szoom->Append((char*)"ZOOMx3");
    Szoom->Append((char*)"ZOOMx4");
    Szoom->Append((char*)"ZOOMx5");
    Szoom->Append((char*)"ZOOMx6");
    Szoom->Append((char*)"ZOOMx7");
    Szoom->Append((char*)"ZOOMx8");
    Szoom->Append((char*)"ZOOMx9");
    Szoom->Append((char*)"ZOOMx10");
	
	Sdivisor=new SpinBoxS(304,376,150,24);
	Sdivisor->Append((char*)"8.880 m/s");
    Sdivisor->Append((char*)"17.900 m/s");
    Sdivisor->Append((char*)"35.500 m/s");
    Sdivisor->Append((char*)"66.000 m/s");
    Sdivisor->Append((char*)"124.000 m/s");
    Sdivisor->Append((char*)"212.000 m/s");
    
    BModoDibujo=new CBoton(425,344,(char*) "POINT");

                                      
   	while(XPending(Midisplay))  XNextEvent (Midisplay, &event);    	
   	
   	Repaint();   	
	Repintado();
   	redraw();
   	
   	
#if YesWindows
	MiBAUDIOS=CBR_115200;
    if(hSerial)CloseRs232();
#else 
	MiBAUDIOS=B115200;
    if(fdrs232)CloseRs232();    
#endif	
	
	z=SearchPort((char*)"OSCI=");
	if(z==-1)
			 { 
				 printf("No Osci %d\n",z);
				 Bdevice->Value( (char *) "No Osci");
			 }
			else
		     { 
				MODEMDEVICE=myport[z];
	#if YesWindows
				if(hSerial)CloseRs232();
	#else		
				if(fdrs232)CloseRs232();
	#endif		 
				IniRs232();				
				portok=1;
				PrintConsola((char *) "Test 3.3V");				
				V33=test3v3();
				Bdevice->Value(MODEMDEVICE);
				PrintSerial((char *) "DIV16");	PrintSerial((char *)"\n");	
			 }
	
	Stimer->SetValue(xtiempo2);
	Sdivisor->SetValue(3);
	CalldivisorSelect();
	
	MODOLINE=0;
	BModoDibujo->SetValue(MODOLINE);
	BModoDibujo->SetLabel((char *) "LINE" );
	
	ModifiG();	
	Repaint();
	
   	 
	while(27!=t)
	 {
		 DelayMs(10);	  
		 MiTimer();	
		 
          if(XPending(Midisplay))
                 {
                  XNextEvent (Midisplay, &event);
                  Mievent=&event;
	                 switch (event.type)
                         {
                         case Expose:
                            redraw();
                            break;
                         case KeyPress:
                            do_KeyPress ();
                            break;
                         case KeyRelease:
                            do_KeyRelease ();
                            break;
                          case MotionNotify:
                            mouse(3);
                            break;
                          case ButtonPress:
                            mouse(4);
                            break;
                          case ButtonRelease:
                            mouse(5);
                            break;
                         default:          
                            break;
                         }

                  } 
         
                  t=inkey();
                  mouse_x=XMOUSE;
				  mouse_y=YMOUSE;	
                  SETBUFFER=1;
                  if(KMOUSE==0) f2=0;
                  if(f2==0 && CMOUSE==1 && KMOUSE==1 )
                   {
					   
					if(Bexit->get(mouse_x,mouse_y)) 
						{						 
						 goto fin;	
						}   
					if(BDOWN_T->get(mouse_x,mouse_y)) 
						{
						 RadioButton1->set(0); RadioButton2->set(0);RadioButton3->set(1);RadioButton4->set(0);
						 if(MODO==1)DelayMs(300);
						 MODO=3; 
						 FinContador=0;
						 ContadorI=0;
						 PrintSerial((char *)"GETDOWN=\n"); 
						 BDOWN_T->Dibujar(1);
						 goto salir1;
						}
					if(BUP_T->get(mouse_x,mouse_y)) 
						{
						 RadioButton1->set(0); RadioButton2->set(1);RadioButton3->set(0);RadioButton4->set(0);
						 if(MODO==1)DelayMs(300);
						 MODO=2; 
						 FinContador=0;
						 ContadorI=0;
						 PrintSerial((char *)"GETUP=\n"); 
						 BUP_T->Dibujar(1);
						 goto salir1;
						}					
					
//____modo						
					if(RadioButton1->get(mouse_x,mouse_y))		//Auto
						{
						 if(!RadioButton1->value()) 							
							{RadioButton1->set(1); RadioButton2->set(0);RadioButton3->set(0);RadioButton4->set(0);}
						 RadioButton1->Dibujar();
						 MODO=1; 					 
						 goto salir1;						 
						}
					if(RadioButton2->get(mouse_x,mouse_y))
						{
						 if(!RadioButton2->value()) 
							{RadioButton1->set(0); RadioButton2->set(1);RadioButton3->set(0);RadioButton4->set(0);}
						 RadioButton2->Dibujar();
						 if(MODO==1)DelayMs(300);
						 MODO=2; 
						 FinContador=0;
						 ContadorI=0;
						 PrintSerial((char *)"GETUP=\n");  					 
						 goto salir1;						 
						}
					if(RadioButton3->get(mouse_x,mouse_y))
						{
						 if(!RadioButton3->value()) 
							{RadioButton1->set(0); RadioButton2->set(0);RadioButton3->set(1);RadioButton4->set(0);}
						 RadioButton3->Dibujar();	

						 if(MODO==1)DelayMs(300);
						 MODO=3; 
						 FinContador=0;
						 ContadorI=0;
						 PrintSerial((char *)"GETDOWN=\n"); 				 
						 goto salir1;						 
						}
//Voltios						
					if(RadioButton4->get(mouse_x,mouse_y))		
						{
						 if(!RadioButton4->value()) 
							{RadioButton1->set(0); RadioButton2->set(0);RadioButton3->set(0);RadioButton4->set(1);}
						 RadioButton4->Dibujar();						 
						 MODO=0; 
						 goto salir1;						 
						}
//_timer muestras del voltimetro
					z=Stimer->get(mouse_x,mouse_y);
					if(z==2) 	{	Stimer->Decrem(); xtiempo2=Stimer->GetValue();	ModifiG(); goto salir1;	}
					if(z==1) 	{	Stimer->Increm(); xtiempo2=Stimer->GetValue();	ModifiG(); goto salir1;	}
//_Desplazamiento
					z=Sdesplazamiento->get(mouse_x,mouse_y);
					if(z==2) 	{	Sdesplazamiento->Decrem(); DESPLAZAMIENTO=Sdesplazamiento->GetValue(); 
									ModifiG(); goto salir1;	}
					if(z==1) 	{	Sdesplazamiento->Increm(); DESPLAZAMIENTO=Sdesplazamiento->GetValue(); 
									 ModifiG(); goto salir1;	}					
//__Zoom___
					z=Szoom->get(mouse_x,mouse_y);
					if(z==2) 	{	Szoom->Decrem();  OnSzoomSelect(); Representar(1); goto salir1;	}
					if(z==1) 	{	Szoom->Increm();  OnSzoomSelect(); Representar(1); goto salir1;	}
//__Muestras__		
					z=Sdivisor->get(mouse_x,mouse_y);
					if(z==2) 	{	Sdivisor->Decrem();  CalldivisorSelect(); goto salir1;	}
					if(z==1) 	{	Sdivisor->Increm();  CalldivisorSelect(); goto salir1;	}
//___LINE___POINT__
					if(BModoDibujo->get(mouse_x,mouse_y))
						{
						 if(BModoDibujo->GetValue()) 
							{
							 MODOLINE=0;
							 BModoDibujo->SetValue(MODOLINE);
							 BModoDibujo->SetLabel((char *) "LINE" );
							 
							}
							else
							{
							 MODOLINE=1;
							 BModoDibujo->SetValue(MODOLINE);
							 BModoDibujo->SetLabel((char *) "POINT");
							}
						 BModoDibujo->Dibujar();						 
						 goto salir1;						 
						}
					
					
					
					goto salir12;
salir1:						
					Repaint(); Representar(1); redraw();
					DelayMs(90);
salir12:   					   
                   // printf("mouse  XMOUSE=%d   YMOUSE=%d\n",XMOUSE,YMOUSE);
                    f2=1;                         
                   }
	 }
	 
fin:
		printf("Fin de programa xRadio\n");
		mode(2);
		return 0; 
}

void Repaint(void)
{	
	FONTY=2; FONTX=1;
	clear(6);
	C_PAPER=6;
	
	
	Bexit->Dibujar();
	//Bacerca->Dibujar();
	RadioButton1->Dibujar();
	RadioButton2->Dibujar();
	RadioButton3->Dibujar();
	RadioButton4->Dibujar();
	StaticText1->Dibujar();
	StaticText2->Dibujar();
	
	Tvoltios->Dibujar();
	Stimer->Dibujar();
	Sdesplazamiento->Dibujar();
	Tdesplaza->Dibujar();
	
	BDOWN_T->Dibujar();
	BUP_T->Dibujar();
	
	Szoom->Dibujar();
	Sdivisor->Dibujar();
	
	Tdivisor->Dibujar();
	BModoDibujo->Dibujar();
	Bdevice->Dibujar();
	
	FONTY=1; FONTX=1; PAPER=6;
	printc(304,440,(char *)"F=(muestras/s)/(9.8666*divisiones)");
	
	FONTY=2; FONTX=2;
	Titulo->Dibujar();

	Repintado();				
    redraw();
}



void MiTimer()
{
  int nbytes;
 unsigned int z,zz;
 
	tiempo1--;	
	tiempo2--;	
	tiempo3--;


// cada __tiempo2
	 if(portok==1 && tiempo2<0)
    {
        tiempo2=10;
        
#if YesWindows
		while(( nbytes = ReadSerie(hSerial, Binput2, 1)>0 ))
#else		
			while(( nbytes = read(fdrs232, Binput2, 1)>0 ))
#endif			
			{
			 	Binput[ContadorI]=Binput2[0];
				if(ContadorI<MAXINPUT-1)	
					{
						ContadorI++;
						//printf(" <<%d %d\n",ContadorI,Binput2[0]);
						//sprintf(LVARI,"Conta=%d",ContadorI);	printConsole(LVARI);
						if(ContadorI==820)
							{
							 for(z=10,zz=0;z<810;z++,zz++) DatosPan[zz]=Binput[z];																		
							 Representar(0);
							 
							 if(!strncmp((char *)Binput+810,"FIN",3))
							 {
								 tiempo3=XTIEMPO3;
								 tiempo2=1;							 
							 }
							}
					}
					else
					{ 	FinContador=1;}									
			}
		}	
// cada __tiempo1
	if(portok==1 && MODO==0 && tiempo1<0)
		{	
			RepresentarVol((unsigned char)Binput[15]);
			tiempo1=xtiempo2;			
			FinContador=0;
			ContadorI=0;
			PrintSerial((char *)"VOL=\n");
		}
// cada __tiempo3 
		if(portok==1 && MODO==1 && tiempo3<0)
		{
			tiempo3=50; //120;			
			FinContador=0;
			ContadorI=0;
			PrintSerial((char *)"GETUP=\n"); 
		}		
}

//________________________________________

void Repintado(void)
{	
 int z;
		INK=1;
		bar( 0, 0, 800, 270 );
		INK=3;
		for(z=30;z<800;z+=10)	line(z,4,z,260);
		INK=0;
		for(z=30;z<800;z+=100) line(z,4,z,260);
		for(z=4;z<261;z+=51)  line(31,z,798,z);
		FONTY=1; FONTX=1;
		PAPER=1;
		printc(2,1,(char *)"5");
		printc(2,128,(char *)"2.5");
		printc(2,246,(char *)"0");	
		FONTY=2; FONTX=1;	
}	

//________________________________________
void ModifiG()
{
#ifdef BOTONES 	
	printf("ZOOM=%d    DESPLAZAMIENTO=%d    Timer=%d\n",ZOOM,DESPLAZAMIENTO,xtiempo2);
#endif
}	



void  Representar(int z)
{
  int x,xx;
  long z1;
  xx=0;
  
	if(z==0)for(x=0;x<800 ;x++)
			{
				z1=(1683*(unsigned char)DatosPan[x])/(V33*10);		
				DatosPan[x]=z1;
			}	
	Repintado();
	INK=4;
	//setcolor(255,0,0);
	if(MODOLINE==1)
	{
		 if(ZOOM==1)
			{for(x=DESPLAZAMIENTO;x<770 && xx<770;x++,xx+=ZOOM) 	plot(xx+30,260-DatosPan[x]);
			}
		  else
		    {for(x=DESPLAZAMIENTO;x<768 && xx<770+ZOOM;x++,xx+=ZOOM)	line(xx+30,260-DatosPan[x],xx+30+ZOOM,260-DatosPan[x]);
			}		  
	}
	else
	{
		 for(x=DESPLAZAMIENTO;x<768 && xx<770+ZOOM;x++,xx+=ZOOM) line(xx+30,260-DatosPan[x],xx+30+ZOOM,260-DatosPan[x+1]);   //dcBuffer->DrawLine(xx+30,260-DatosPan[x],xx+30+ZOOM,260-DatosPan[x+1]);
	}
	redraw();
}



void RepresentarVol(int z)
{
 long z1;
 
	z1=(z*3300)/V33;
#if DEBUG 	
	//printf("Voltios=%li mV\n",z1);
	//printf("%d   %d",V33,z);	
#endif	
	sprintf(LVARI,"%limV",z1);
	Tvoltios->Value(LVARI);
	Tvoltios->Dibujar();	
    Repintado();
    
    z1=(1683*z)/(V33*10);	z=z1;
	INK=4;
	//setcolor(0,0,255);  	
	line(0,259-z,800,259-z);
	redraw();
}

//______________________test 3.3V	
int test3v3(void)
{
 unsigned int zz;
 int nbytes;
 
 ContadorI=0;	
 printf("Test 3V3");
 DelayMs(2000);
 PrintSerial((char *)"TEST=\n");

	for(zz=0;zz<15;zz++)
		{
		 DelayMs(200);
#if YesWindows
		while(( nbytes = ReadSerie(hSerial, Binput2, 1)>0 ))
#else		
		while(( nbytes = read(fdrs232, Binput2, 1)>0 ))
#endif			
			{
			  Binput[ContadorI]=Binput2[0];
			  //printf(" %d %d\n",ContadorI,Binput2[0]);
			  if(ContadorI<MAXINPUT-1)	
					{
					 ContadorI++;
					 if(ContadorI>29) goto salir;						
					}													
			}
		}
salir:
	zz=(unsigned char)Binput[10]+(unsigned char)Binput[11]+(unsigned char)Binput[12]+(unsigned char)Binput[13];
	zz=zz>>2;
	printf("Test 3v3=%d\n",zz);
	return(zz);
}



void OnSzoomSelect(void)
{
	int z;
		z=Szoom->GetValue();
		ZOOM=z+1;
}


void CalldivisorSelect(void)
{
	int z;

		z=Sdivisor->GetValue();

	switch(z) 
	{
    case 0:
		sprintf(LVARI,"DIV128");   
    break;
	case 1:
		sprintf(LVARI,"DIV64");   
    break;
    case 2:
		sprintf(LVARI,"DIV32");   
    break;
    case 3:
		sprintf(LVARI,"DIV16");   
    break;
    case 4:
		sprintf(LVARI,"DIV8");   
    break;
    case 5:
		sprintf(LVARI,"DIV4");   
    break;
	}
	
	Tdivisor->Value(LVARI); 										
	PrintSerial(LVARI);	PrintSerial((char *)"\n");		
	//printf("%s\n",LVARI);
}
 


//______________

int SearchPort(char *placa)
{
		int z,zz,nbytes;
		char temp[15];
		
		printf("Search serial\n");
//		PrintConsola((char *)"Search serial");
 #if YesWindows
		for (z=0;z<11;z++)
 #else
			for (z=0;z<7;z++)
 #endif		
			{
				MODEMDEVICE=myport[z];
				printf("Test Port %s\n",MODEMDEVICE);
//				PrintConsola(MODEMDEVICE);
				if(0==IniRs232())
				   {   
					printf("->busqueda>%s   %s\n",MODEMDEVICE,placa);            
					DelayMs(1500);
					PrintSerial((char *)"\n\n");
					sprintf(temp,"%s\n",placa); 	
					PrintSerial((char *) temp);			
					DelayMs(100);
					ContadorI=0; 
					for(zz=0;zz<20;zz++)
					   {
						DelayMs(100); 
#if YesWindows
						while(( nbytes = ReadSerie(hSerial, Binput2, 1)>0 ))
#else		
						while(( nbytes = read(fdrs232, Binput2, 1)>0 ))
#endif		
							{	
//							    printf("Leerx %d -> %s\n",nbytes,Binput2);
								Binput[ContadorI]=Binput2[0];
								ContadorI++;
								if (Binput2[0] == '\n')
								   {
									if(ContadorI<2)ContadorI=2;   
									Binput[ContadorI-1]=0;
									ContadorI=0;	
									sprintf(LVARI,"%s",Binput);
//                                    printf("==%s\n",LVARI);
									if(!strncmp(LVARI,"OK",2))
									   {
										printf("%s found at %s\n",placa,MODEMDEVICE);
										CloseRs232();                                   
										return z;
									   }			
								    }
							}	  	  
						} 
						 					 						   
					}

			 }
			printf("OSCI no found \n");
			return -1;
}

