#include <string.h>

#include "objetos.h"
#include "xxgrafi.h"

#include "color.h"


//____________SpinBoxD____________
	SpinBoxD::SpinBoxD(int xi, int yi, int anchoi, int altoi)
	{
	 int z;
		for(z=0;z<15;z++) name[z][0]=0;
		x=xi; y=yi; xx=x+anchoi;  yy=y+altoi; valor=0;
	}
	SpinBoxD::SpinBoxD(int xi, int yi)
	{
	 int z;
		for(z=0;z<15;z++) name[z][0]=0;
		x=xi; y=yi; xx=x+100;  yy=y+24;	 valor=0;
	}
	void SpinBoxD::SetValue(int n)
	{
		valor=n;
	}
	int SpinBoxD::GetValue()
	{
		return(valor);
	}
	void SpinBoxD::Increm()
	{	
	 int z;
		for(z=0;z<15 && name[z][0]!=0 ;z++) ;	
		if(valor<z-1) valor++;
	}
	void SpinBoxD::Decrem()
	{
		if(valor>0) valor--;
	}
	void SpinBoxD::Append(char *texto)
	{
	 int z;
		for(z=0;z<15;z++) 
			if(name[z][0]==0)
				{				
				 strncpy(&name[z][0],texto,19);
				 break;
				}
	}
	void SpinBoxD::Dibujar()
	{
		char temp[20];
			if(name[valor][0]==0) return;
			sprintf(temp,"%s",&name[valor][0]);
			INK=C_SPINPAPER;	 	bar(x,y,xx,yy);
		 	INK=0;	box(x,y,xx,yy);	
		 	line(x+18,y,x+18,yy); 
		 	line(x,y+(yy-y)/2,x+18,y+(yy-y)/2);
		 	
		 	line(x,y+(yy-y)/2,x+9,y); 	line(x+9,y,x+18,y+(yy-y)/2);
		 	line(x,y+(yy-y)/2,x+9,yy);  line(x+9,yy,x+18,y+(yy-y)/2);


			PAPER=C_SPINPAPER; INK=C_SPINTEXT;
			printc( x+20, y+5,temp);

	}
	unsigned char SpinBoxD::get(int xi, int yi)
	{
		if(xi>x && xi<x+20 && yi>y && yi<yy-(yy-y)/2)	 return(1);
			if(xi>x && xi<x+20 && yi>yy-(yy-y)/2 && yi<yy) return(2);
			return(0);
	}
	



//____________SpinBoxS____________
	SpinBoxS::SpinBoxS(int xi, int yi, int anchoi, int altoi)
	{
	 int z;
		for(z=0;z<15;z++) name[z]=NULL;
		x=xi; y=yi; xx=x+anchoi;  yy=y+altoi; valor=0;
	}
	SpinBoxS::SpinBoxS(int xi, int yi)
	{
	 int z;
		for(z=0;z<15;z++) name[z]=NULL;
		x=xi; y=yi; xx=x+100;  yy=y+24;	 valor=0;
	}
	void SpinBoxS::SetValue(int n)
	{
		valor=n;
	}
	int SpinBoxS::GetValue()
	{
		return(valor);
	}
	void SpinBoxS::Increm()
	{	
	  int z;
		for(z=0;z<15 && name[z]!=NULL ;z++) ;	
		if(valor<z-1) valor++;
	}
	void SpinBoxS::Decrem()
	{
		if(valor>0) valor--;
	}
	void SpinBoxS::Append(char *texto)
	{
	 int z;
		for(z=0;z<15;z++) 
			if(name[z]==NULL)
				{
				 name[z]=texto;	
				 break;
				}
	}
	void SpinBoxS::Dibujar()
	{
		  char temp[20];
		    if(name[valor]==NULL) return;
			sprintf(temp,"%s",name[valor]);
			INK=C_SPINPAPER;	 	bar(x,y,xx,yy);
		 	INK=0;	box(x,y,xx,yy);	
		 	line(x+18,y,x+18,yy); 
		 	line(x,y+(yy-y)/2,x+18,y+(yy-y)/2);
		 	
		 	line(x,y+(yy-y)/2,x+9,y); 	line(x+9,y,x+18,y+(yy-y)/2);
		 	line(x,y+(yy-y)/2,x+9,yy);  line(x+9,yy,x+18,y+(yy-y)/2);

			PAPER=C_SPINPAPER; INK=C_SPINTEXT;
			printc( x+20, y+5,temp);
	}
	
	unsigned char SpinBoxS::get(int xi, int yi)
	{
		if(xi>x && xi<x+20 && yi>y && yi<yy-(yy-y)/2)	 return(1);
			if(xi>x && xi<x+20 && yi>yy-(yy-y)/2 && yi<yy) return(2);
			return(0);
	}
	


//____________SpinBox____________

	SpinBox::SpinBox(int xi, int yi, int anchoi, int altoi, int mini, int maxi, int increi)
		{
			x=xi; y=yi; xx=x+anchoi;  yy=y+altoi; 
			max=maxi;  min=mini; incre=increi; valor=mini;
		}
	SpinBox::SpinBox(int xi, int yi)
		{
			x=xi; y=yi; xx=x+50;  yy=y+24; 
			max=10;  min=0; incre=1; valor=0;
		}
	void SpinBox::SetValue(int n)
		{
			valor=n;
		}
	int SpinBox::GetValue()
		{
			return(valor);
		}
	unsigned char SpinBox::get(int xi, int yi)
		{
			if(xi>x && xi<x+20 && yi>y && yi<yy-(yy-y)/2)	 return(1);
			if(xi>x && xi<x+20 && yi>yy-(yy-y)/2 && yi<yy) return(2);
			return(0);
		}
	void SpinBox::Increm()
		{
			valor++;
			if(valor>max) valor=max;
		}
	void SpinBox::Decrem()
		{
			valor--;
			if(valor<min) valor=min;
		}
	void SpinBox::Dibujar()
		{
		  char temp[20];
			sprintf(temp,"%d",valor);		
			
			INK=C_SPINPAPER;	 	bar(x,y,xx,yy);
		 	INK=0;	box(x,y,xx,yy);	
		 	line(x+18,y,x+18,yy); 
		 	line(x,y+(yy-y)/2,x+18,y+(yy-y)/2);
		 	
		 	line(x,y+(yy-y)/2,x+9,y); 	line(x+9,y,x+18,y+(yy-y)/2);
		 	line(x,y+(yy-y)/2,x+9,yy);  line(x+9,yy,x+18,y+(yy-y)/2);
		 	
		    PAPER=C_SPINPAPER; INK=C_SPINTEXT;
			printc( x+20, y+5,temp);
		}


//____________EDIT TEXT____________
	TextoE::TextoE(int xi, int yi, char *texto)
		{
			x=xi; y=yi; xx=x+100;  yy=y+24;
			strncpy(name,texto,19);
		}
	TextoE::TextoE(int xi, int yi, int ancho, int alto, char *texto)
		{
			x=xi; y=yi; xx=x+ancho;  yy=y+alto; 
			strncpy(name,texto,19);
		}
	void TextoE:: Value(int n)
		{
			char temp[20];
			sprintf(temp,"%d",n);
			strncpy(name,temp,19);

		}
	void TextoE:: Value(float n)
		{
			char temp[20];
			sprintf(temp,"%.2f",n);
			strncpy(name,temp,19);
		}
	void TextoE:: Value(char *texto)
		{
			strncpy(name,texto,19);
		}
	void TextoE:: Dibujar()
		{
			INK=C_EDITPAPER;	 	bar(x,y,xx,yy);
		 	INK=0;		 	box(x,y,xx,yy);	
		 	
			PAPER=C_EDITPAPER; INK=C_EDITTEXT;
			printc( x+4, y+4,name);

		}		

//____________TEXTOS____________
	TextoS::TextoS(int xi, int yi, char *texto)
		{
			x=xi; y=yi;
			strncpy(name,texto,19);
		}
	void TextoS:: Dibujar()
		{
			
		PAPER=C_PAPER; INK=C_TEXT;
		 printc( x, y+3,name);

		}
	void TextoS:: DibujarColor(int text, int paper )
		{
			PAPER=paper; INK=text;
			printc( x, y+3,name);
		}

//____________CHEQUEO____________

	Chequeo::Chequeo(int xi, int yi, char *texto) 
		{
			x=xi; y=yi; xx=x+16;  yy=y+16; estado=0;
			 strncpy(name,texto,19);
		}
	Chequeo::Chequeo(int xi, int yi, char *texto, bool estadoi) 
		{
			x=xi; y=yi; xx=x+16;  yy=y+16; estado=estadoi;
			 strncpy(name,texto,19);
		}
	void Chequeo::Dibujar()
		{
		 	INK=C_CHEQUEO0;	 	bar(x,y,xx,yy);		 	
		 	INK=0;		 	box(x,y,xx,yy);
		 	if(estado==1) { INK=C_CHEQUEO1; bar(x+4,y+4,xx-4,yy-4);	}

			PAPER=C_PAPER; INK=C_TEXT;
			printc( xx+4, y,name);
		}
					
	bool Chequeo::get(int xi, int yi)
		{
			if(xi>x && xi<xx && yi>y && yi<yy)
				return(1);
			else
				return(0);
		}
	void Chequeo::set(bool s)
		{
			estado=s;
		}
	bool Chequeo::value(void)
		{
			return(estado);
		}

//___________Xboton
Xboton::Xboton(int xi, int yi,int ancho,int alto,char *texto) 
		{
			x=xi; y=yi; xx=x+ancho;  yy=y+alto;
			strncpy(name,texto,19);
		}
Xboton::Xboton(int xi, int yi, char *texto) 
		{
			x=xi; y=yi; xx=x+100;  yy=y+24;
			strncpy(name,texto,19);
		}		
void Xboton::SetLabel(char *texto)
		{
		 strncpy(name,texto,19);	
		}
bool Xboton::get(int xi, int yi)
		{
			if(xi>x && xi<xx && yi>y && yi<yy)
				return(1);
			else
				return(0);
		}			
				
//____________BOTON____________
	Boton::Boton(int xi, int yi,int ancho,int alto,char *texto) : Xboton(xi,yi,ancho,alto,texto)
		{		}
	Boton::Boton(int xi, int yi, char *texto) : Xboton(xi,yi,texto)
		{		}
	void Boton::Dibujar(bool s)		
		{
			int w1,h1,z,zf;
			if(s)  //pulsado
			{
			 INK=C_BOTONPAPER1;	 	bar(x,y,xx,yy);
			 INK=0;		 	box(x,y,xx,yy);
			INK=1;	 	box(x+1,y+1,xx-1,yy-1);
			INK=1;	 	box(x+2,y+2,xx-2,yy-2);
			PAPER=C_BOTONPAPER1; INK=C_BOTONTEXT1;	
			}
			else   //no pulsado
			{
		 	INK=C_BOTONPAPER0;	 	bar(x,y,xx,yy);
		 	INK=8;	 	box(x+2,y+2,xx-2,yy-2);
		 	INK=8;	 	box(x+1,y+1,xx-1,yy-1);
		 	INK=0;		 	box(x,y,xx,yy);	
		 	PAPER=C_BOTONPAPER0; INK=C_BOTONTEXT0;
			}
			switch(FONTX)
			{
				case 1:
					zf=8;
				break;
				
				case 2:
					zf=16;
				break;
				
				default:
				zf=16;
				
			}
			z=(xx-x)/2; w1=strlen(name)*zf; z-=(w1/2);
			printc( x+z, y+5,name);

		}
	


//_____________BOTON__CHEQUEO_________

	CBoton::CBoton(int xi, int yi, char *texto) : Xboton(xi,yi,texto)
		{ estado=0;	}
	CBoton::CBoton(int xi, int yi,int ancho,int alto,char *texto) : Xboton(xi,yi,ancho,alto,texto)
		{ estado=0;	}
	void CBoton::Dibujar()
		{
			int w1,h1,z,zf;
			
			if(estado==1)
			{
				INK=C_CBOTONPAPER1;	 	bar(x,y,xx,yy);
				INK=8;	 	box(x+2,y+2,xx-2,yy-2);
				INK=8;	 	box(x+1,y+1,xx-1,yy-1);
				INK=0;		 	box(x,y,xx,yy);
				PAPER=C_CBOTONPAPER1; INK=C_CBOTONTEXT1;
			}
		 	else
		 	{
				INK=C_CBOTONPAPER0;	 	bar(x,y,xx,yy);
				INK=0;		 	box(x,y,xx,yy);
				INK=1;	 	box(x+1,y+1,xx-1,yy-1);
				INK=8;	 	box(x+2,y+2,xx-2,yy-2);
				PAPER=C_CBOTONPAPER0; INK=C_CBOTONTEXT0;
		 	}	 	
			switch(FONTX)
			{
				case 1:
					zf=8;
				break;
				
				case 2:
					zf=16;
				break;
				
				default:
				zf=16;
				
			}
			z=(xx-x)/2; w1=strlen(name)*zf; z-=(w1/2);
			printc( x+z, y+5,name);
		}
					
	
	void CBoton::SetValue(bool s)
		{
			estado=s;
		}
	bool CBoton::GetValue(void)
		{
			return(estado);
		}

//__________________________
